/* 
 * Docp_Main.c --
 *
 *    main function for the Omuses demo collection
 *    (this file may be replaced by tclAppInit.c or tkAppInit.c of
 *     a Tcl/Tk distribution, provided that the modules Hqp
 *     and Docp are initialized)
 *
 *  rf, 2/10/98
 */

#include <tcl.h>

/*
 * prototypes for module initializations
 */

int Hqp_Init _ANSI_ARGS_((Tcl_Interp *interp));
int Docp_Init _ANSI_ARGS_((Tcl_Interp *interp));

/*
 * the main function
 */

int
main(argc, argv)
     int argc;
     char **argv;
{
  Tcl_Main(argc, argv, Tcl_AppInit);
  return 0;
}

/*
 * Tcl_AppInit function
 */

int
Tcl_AppInit(interp)
     Tcl_Interp *interp;
{
  if (Tcl_Init(interp) == TCL_ERROR) {
    return TCL_ERROR;
  }

  if (Hqp_Init(interp) == TCL_ERROR) {
    return TCL_ERROR;
  }
  Tcl_StaticPackage(interp, "Hqp", Hqp_Init, NULL);

  if (Docp_Init(interp) == TCL_ERROR) {
    return TCL_ERROR;
  }
  Tcl_StaticPackage(interp, "Docp", Docp_Init, NULL);

  Tcl_SetVar(interp, "tcl_rcFileName", "~/.tclshrc", TCL_GLOBAL_ONLY);
  return TCL_OK;
}
